//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.tid;
import java.io.*;

public class TID implements Serializable
{
	private byte[] b;

	public TID()
	{
	}

	public TID(byte[] b)
	{
		this.b=b;
	}

	public byte[] getBytes()
	{
		return b;
	}

	public boolean equals(Object o)
	{
		if (!(o instanceof TID))
			return false;
		TID otid=(TID)o;
		byte[] ob=otid.b;
		if (b.length != ob.length)
			return false;
		int i;
		int l=b.length;
		for (i=0;i<l;++i)
			if (b[i]!=ob[i])
				return false;
		return true;
	}

	public int hashCode()
	{
		byte[] h=new byte[4];
		int i;
		for (i=0;i<4;++i)
			h[i]=0;
		int l=b.length;
		for (i=0;i<l;++i)
			h[i%4]^=b[i];
		int rv=0;
		for (i=0;i<4;++i)
			rv=(rv<<8)|h[i];
		return rv;
	}

	public static long getTimeStamp(byte[] b)
	{
		long t=0;
		int i;
		for (i=0;i<8;++i)
		{
			t<<=8;
			t|=(b[i])&255;
		}
		return t;
	}

	public long getTimeStamp()
	{
		return getTimeStamp(b);
	}
}
