//Copyright (c) 1998 The Open Group
//
//Permission to use, copy, modify, and distribute this software and its documentation for
//any purpose and without fee is hereby granted, provided that the above copyright notice
//appears in all copies and that both the copyright notice and this permission notice
//appear in supporting documentation, and that the name of ("TOG") or The Open Group not
//be used in advertising or publicity pertaining to distribution of the software without
//specific, written prior permission.
//
//THE OPEN GROUP DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT
//SHALL TOG BE LIABLE FOR ANY SPECIAL, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
//WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN ACTION OF CONTRACT,
//NEGLIGENCE, OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
//PERFORMANCE OF THIS SOFTWARE. 

package ORG.opengroup.axtp.xface;
import ORG.opengroup.axtp.transaction.*;
import ORG.opengroup.xface.*;
import ORG.opengroup.jar.*;
import ORG.opengroup.axtp.*;

/**
 * An eXecution request.
 */
public class XX 
	extends XExecutionObject
	implements X, TransactionFromClient
{
	private boolean primary=true;
	private long transactionDuration=0;
	private long zid=0;

	public void setXObj(XObj xObj)
		throws NumberFormatException, Invalid64Exception
	{
		super.setXObj(xObj);
		String t;
		t=xObj.getAtt("PRIMARY");
		if (t==null)
			primary=true;
		else
			primary=Boolean.valueOf(t).booleanValue();
		t=xObj.getAtt("DURATION");
		if (t==null)
			transactionDuration=0;
		else
			transactionDuration=Long.parseLong(t);
		t=xObj.getAtt("ZID");
		if (t!=null)
			zid=Long.parseLong(t);
	}

	public void setPrimary(boolean primary)
	{
		this.primary=primary;
	}

	public boolean getPrimary()
	{
		return primary;
	}

	public boolean isPrimary()
	{
		return primary;
	}

	public void setTransactionDuration(long v)
	{
		transactionDuration=v;
	}

	public long getTransactionDuration()
	{
		return transactionDuration;
	}

	public void setZID(long zid)
	{
		this.zid=zid;
	}

	public long getZID()
	{
		return zid;
	}

	/**
	 * Refreshes the XML object with current data held by the face object.
	 * (Called by XObj.toString().)
	 */
	public void refreshXObj()
	{
		super.refreshXObj();
		if (primary)
			xObj.removeAtt("PRIMARY");
		else
			xObj.putAtt("PRIMARY","TRUE");
		if (transactionDuration==0)
			xObj.removeAtt("DURATION");
		else
			xObj.putAtt("DURATION",""+transactionDuration);
		xObj.putAtt("ZID",""+zid);
	}
}
